#ifndef TRGBIOS_H
#define TRGBIOS_H

typedef void (*TrgIntService)(void);

// [U`荞ݗp萔
//   trg_regintsrv֐̈Ɏg
#define TRG_INTID_BSILVI    0
#define TRG_INTID_BSIP0     1
#define TRG_INTID_BSIP1     2
#define TRG_INTID_BSIP2     3
#define TRG_INTID_BSIP3     4
#define TRG_INTID_BSISRE6   5
#define TRG_INTID_BSISR6    6
#define TRG_INTID_BSIST6    7
#define TRG_INTID_BSICSI10  8
#define TRG_INTID_BSITMH1   9
#define TRG_INTID_BSITM50   10
#define TRG_INTID_BSITM000  11
#define TRG_INTID_BSITM010  12
#define TRG_INTID_BSITM51   13
#define TRG_INTID_BSBRK     14

/*================================================================
gZBIOSJ֐
================================================================*/

// USBI[v
#define trg_usbopen() \
    (( void (*)(               ) ) ( 0x18C0 )) \
    ( )

// USBN[Y
#define trg_usbclose() \
    (( void (*)(               ) ) ( 0x18C4 )) \
    ( )

// USBɕ𑗐M
#define trg_puts(SRC) \
    (( void (*)(const char *src) ) ( 0x18C8 )) \
    (SRC)

// USB1MiM܂Ő͖߂Ȃj
#define trg_getc() \
    (( char (*)(               ) ) ( 0x18CC )) \
    ( )

// USB̃Xe[^X𒲂ׂ
// NULLw肵Ăǂ
#define trg_getstatus(SRC) \
    (( unsigned char (*) (void *src) ) ( 0x18D0 )) \
    (SRC)

// Mobt@̃f[^𒲂ׂ
#define trg_getrecvcount() \
    (( unsigned short (*)(     ) ) ( 0x18D4 )) \
    ( )

// Cӂ̒̃oCif[^𑗐M
#define trg_senddata(SRC,LEN) \
    (( void (*)(unsigned char *src,unsigned short len) ) ( 0x18D8 )) \
    (SRC,LEN)

// Cӂ̒̃oCif[^M
#define trg_recvdata(SRC,LEN) \
    (( void (*)(unsigned char *src,unsigned short len) ) ( 0x18DC )) \
    (SRC,LEN)

// 荞݃[`o^
#define trg_regintsrv(ID,FUNC) \
    (( void (*)(unsigned char id,TrgIntService func)   ) ( 0x18E0 )) \
    (ID,FUNC)

// tbV݃[`̋N
#define trg_flashwr(ID) \
    (( unsigned char (*)(unsigned char id)             ) ( 0x18E4 )) \
    (ID)

#endif
