#ifndef AD_H
#define AD_H


#define AD_CS		P3.0
#define AD_CS_IO	PM3.0


//SingleEnded Mode
#define CH0_S	0x8F	//0x8F	ch0 0b(1 000 11 11) ch0 Single uni exClock
#define CH1_S	0xCF	//0xCF	ch1 0b(1 100 11 11) ch1 Single uni exClock
#define CH2_S	0x9F	//0x9F	ch2 0b(1 001 11 11) ch2 Single uni exClock
#define CH3_S	0xDF	//0xDF	ch3 0b(1 101 11 11) ch3 Single uni exClock
#define CH4_S	0xAF	//0xAF	ch4 0b(1 010 11 11) ch4 Single uni exClock
#define CH5_S	0xEF	//0xEF	ch5 0b(1 110 11 11) ch5 Single uni exClock
#define CH6_S	0xBF	//0xBF	ch6 0b(1 011 11 11) ch6 Single uni exClock
#define CH7_S	0xFF	//0xFF	ch7 0b(1 111 11 11) ch7 Single uni exClock


//Defferential Mode
#define CH01_D	0x8B	//0x8F	ch0 0b(1 000 10 11) ch0 to ch1 Differentiasl uni exClock
#define CH23_D	0x9B	//0xCF	ch1 0b(1 001 10 11) ch2 to ch3 Differentiasl uni exClock
#define CH45_D	0xAB	//0x9F	ch2 0b(1 010 10 11) ch4 to ch5 Differentiasl uni exClock
#define CH67_D	0xBB	//0xDF	ch3 0b(1 011 10 11) ch6 to ch7 Differentiasl uni exClock

#define CH10_D	0xCB	//0x8F	ch0 0b(1 100 10 11) ch1 to ch0 Differentiasl uni exClock
#define CH32_D	0xDB	//0xCF	ch1 0b(1 101 10 11) ch3 to ch2 Differentiasl uni exClock
#define CH54_D	0xEB	//0x9F	ch2 0b(1 110 10 11) ch5 to ch4 Differentiasl uni exClock
#define CH76_D	0xFB	//0xDF	ch3 0b(1 111 10 11) ch7 to ch6 Differentiasl uni exClock


// ֐` 
void AD_Init(void);
unsigned int AD_Input(unsigned char ch);
//unsigned char AD_SWInput(void);

#endif

