//===============================================
//= 78KȈՃ}`[^				=
//= (gWX^Zp2008N8/9gp	=
//= 						=
//=Edv Edv ERv EgJE^	=
//= 						=
//= 						=
//= N SW1Ń[hIASW3Ō		=
//= 蒆SW3Ńj[ʂɖ߂		=
//= j[ʂSW2ɂvOI	=
//=igZBIOSɖ߂j				=
//= 						=
//= 						=
//= 2008/09/07					=
//===============================================

#pragma sfr

#include "trgbios.h"
#include "SPI.h"
#include "AD.h"
#include "LCD.h"

void port_init(void);
void display_init(void);
void interval_DA(void);
void counter_init(void);
void interval_counter(void);
void counter_stop(void);
void counter_start(void);
void voltage(unsigned char ch);
unsigned short V_Conv(int data);
void strcpy(char *d, char *s);
void sprintf(char *buf, char *s, int dat,...);


// O[oϐ
unsigned short frq;
volatile int errno = 0;
unsigned int volt,volt_Max;
unsigned char exec_mode;

unsigned char max_csw_count;
unsigned char sts_psw;
unsigned char sts_osw;
unsigned int  csw_count;

unsigned int  tm50_count;
unsigned char tm50_intcount;
unsigned char tm50_intsts;

#define	MAX_UPDATE_TIME	5000
unsigned int update_timer;

char buf[20];

struct PUTS_TEXT {
	const char *text;
	const unsigned char len;
};

const struct PUTS_TEXT text_mode[] = {
	{"1:Voltage",9},
	{"2.Current",9},
	{"3.Resistance",12},
	{"4.Frequency",11}
};


#define	MODE_VMETER	0
#define	MODE_AMETER	1
#define	MODE_RMETER	2
#define	MODE_FCOUNTER	3


// dv 
void v_meter()
{
	voltage(CH01_D);
}

// dv 
void a_meter()
{
	voltage(CH23_D);
}

// Rv 
void r_meter()
{
	unsigned int ch4;
	unsigned int val;
	ch4=AD_Input(CH4_S);	// ch4̒lŃI[gWB
	do {
		if(ch4 == 0)	{strcpy(buf,"0000@"); break;}
		if(ch4 >= 1014)	{strcpy(buf,"999k@"); break;}
		if(ch4 > 94)	{sprintf(buf,"%3dk@",(10*ch4)/(1024-ch4)); break;}

		if(ch4<=6) {
			val = (10000*ch4)/(1024-ch4);
		} else if (ch4<=13) {
			val = (5000*ch4)/(1024-ch4)*2;
		} else {
			val = (500*ch4)/(1024-ch4)*20;
		}
		sprintf(buf,"%3d@",val);
	} while(0);
	LCD_CursorXY(0,1);
	LCD_LPuts(buf,8,3,1);
}

// gJE^ 
void f_counter()
{
	unsigned int dat;
	if (!tm50_intsts)
		return;
	if (tm50_count >= 4000) {
		dat = tm50_count / tm50_intcount;
		frq = (dat/2)+(dat%2);
		sprintf(buf,"%3dkHz?",frq);
	} else {
		if (tm50_count <= 40) {
			dat = tm50_count * 1000 / tm50_intcount;
		} else if (tm50_count <= 400) {
			dat = tm50_count * 100 / tm50_intcount * 10;
		} else {
			dat = tm50_count * 10 / tm50_intcount * 100;
		}
		frq = (dat/2)+(dat%2);
		sprintf(buf,"%4dHz?",frq);
	}
	LCD_CursorXY(0,1);
	LCD_LPuts(buf,6,3,1);
	tm50_count = 0;
	tm50_intcount = 0;
	tm50_intsts = 0;
	counter_start();
}

// XCb`͏iOFFɉĂ̗̂pj 
unsigned char sw_input(unsigned char count)
{
	unsigned char sw;
	unsigned char retsts;
	retsts = 0;
	if (count != 0) {
		sts_osw = 0;
		sw = 0;
		sts_psw = 0;
		csw_count = 0;
		max_csw_count = count;
	} else {
		sw = (unsigned char )(((AD_Input(CH5_S) >> 8) & 3) ^ 0x3);
		if (sw == sts_psw) {
			csw_count++;
			if (csw_count >max_csw_count) {
				csw_count = 0;
				if (sw == 0) {	// OFFɂȂ
					retsts = sts_osw;
					sts_osw = 0;
				} else {	// ONɂȂ
					sts_osw = sw;
				}
			}
		} else {
			csw_count = 0;
			sts_psw = sw;
		}
	}
	return(retsts);
}

// 샂[hI 
unsigned char m_select()
{
	unsigned char sw;
	// t\S 
	LCD_Clear();
	//LCD_LPuts("0123456789",10,0,1);
	LCD_CursorXY(0,1);
	LCD_Puts("SelectFunction",14);
	LCD_CursorXY(1,3);
	LCD_Puts("SW1:Next  SW3:Enter",19);
	//@\I
	exec_mode = 3;
	sw = 1;	// ŏɉʍXV邽߂̏׍H 
	do {
		if(sw==1) {
			exec_mode = (exec_mode + 1) & 0x3;
			LCD_CursorXY(10,0);
			LCD_Puts("           ",11);
			LCD_CursorXY(0,0);
			LCD_Puts(text_mode[exec_mode].text, text_mode[exec_mode].len);
		}
		sw=sw_input(0);
	} while ((sw != 3) && (sw != 2));
	return(sw);
}

// w肵[hł̓JnO 
void m_start(unsigned char mode)
{
	update_timer = 0;
	LCD_CursorXY(0,3);
	LCD_Puts("            SW3:Exit",20);
	volt=0;
	volt_Max=0;
	switch(mode) {
		case	MODE_VMETER:
				LCD_LPuts(" V:",3,0,1);
				LCD_CursorXY(10,3);
				LCD_Puts("V",1);
				LCD_LPuts("V",1,8,1);
				break;
		case	MODE_AMETER:
				LCD_LPuts(" I:",3,0,1);
				LCD_CursorXY(10,3);
				LCD_Puts("A",1);
				LCD_LPuts("A",1,8,1);
				break;
		case	MODE_RMETER:
				LCD_LPuts(" R:",3,0,1);
				break;
		case	MODE_FCOUNTER:
		default:
				LCD_LPuts(" f:",3,0,1);
				PM0.1=0;
				tm50_count = 0;
				tm50_intcount = 0;
				tm50_intsts = 0;
				counter_start();
				break;
			break;
	}
}

// w肵[hł̓I 
void m_stop(unsigned char mode)
{
	switch(mode) {
		case	MODE_VMETER:
				break;
		case	MODE_AMETER:
				break;
		case	MODE_RMETER:
				break;
		case	MODE_FCOUNTER:
		default:
				counter_stop();
				break;
	}
}

// w肵[hł̓쏈 
void m_exec(unsigned char mode)
{
	switch (mode)
	{
		case MODE_VMETER:	//dv
			if (update_timer++ > MAX_UPDATE_TIME) {	// XVƌȂ̂ŁAԈ 
				v_meter();
				update_timer = 0;
			}
			break;
		case MODE_AMETER:	//dv
			if (update_timer++ > MAX_UPDATE_TIME) {	// XVƌȂ̂ŁAԈ 
				a_meter();
				update_timer = 0;
			}
			break;
		case MODE_RMETER:	//Rv
			if (update_timer++ > MAX_UPDATE_TIME) {	// XVƌȂ̂ŁAԈ 
				r_meter();
				update_timer = 0;
			}
			break;
		case MODE_FCOUNTER:	//gJE^ 
		default:
			f_counter();
			break;
	}
}


// Main֐ 
void main( void )
{

	unsigned char sw;

	port_init();

	// 荞݊֐̓o^ 

	trg_regintsrv(TRG_INTID_BSITM000,interval_DA);
	trg_regintsrv(TRG_INTID_BSITM51,interval_counter);

	while(1)
	{
		display_init(); //I[vjOʕ\ 
		// X^[g҂ SW1҂
		sw_input(16);
		do {
			sw = sw_input(0);
		} while((sw !=1) && (sw != 2));
		if (sw == 2)
			break;
		exec_mode=0;
		//@\؂ւ
		sw = m_select();
		if (sw == 2)
			break;

		//Jn
		sw_input(4);
		m_start(exec_mode);
		do {
			m_exec(exec_mode);
			sw=sw_input(0);
		} while(sw != 3);
		m_stop(exec_mode);
	}
}

// SPI/AD/LCD/DA/|[g 
void port_init(void)
{
	trg_usbopen();	// USB|[gI[v 
	CSI10_Init(0x40,0x1B);
	CSI10_Enable();
	AD_Init();
	LCD_Init();
}

// t\ 
void display_init(void)
{
	LCD_Reset();
	LCD_DefaultSet();
	LCD_Clear();

	LCD_DisplayON();

	LCD_CursorXY(0,0);
	LCD_Puts("Transistor Gijutsu",18);
	LCD_CursorXY(1,1);
	LCD_Puts("MultiFunctionTool 1",19);
	LCD_CursorXY(0,2);
	LCD_Puts("--------------------",20);
	LCD_CursorXY(1,3);
	LCD_Puts("Please Push SW1...",18);

}

// g`@\EStart 
void counter_init(void)
{

		PRM00=0x33;
		CRC00=0x00;
		CR000=0xFFFF;	// 0xA8ȏ (93Hzȉ) 
		TOC00=0x00;
		PM0.0=1;
		TMC00=0x0C;	// JEgJn 
}

// 16rbg^C}荞ݏ 
void interval_DA(void)
{
	return;
}


// JE^Xgbv 
void counter_stop()
{
	TCE51=0;
	MK1L.3=1;		// TM51荞݋֎~ 
	TCL51=0x00;
	TMC51=0x00;
	
	TMC00=0x00;
}


// 8rbg^C}荞ݏ 
void interval_counter(void)
{
	unsigned int dat;
	dat = TM00;
	if ((dat < tm50_count) || (tm50_intcount == 200)) {
		TMC00=0x00;
		P0.1=0;
		counter_stop();
		tm50_intsts = 1;
	} else {
		tm50_count = dat;
		tm50_intcount++;
	}
	return;
}


// JE^X^[g 
void counter_start(void)
{
		TCL51=0x05;		// 1ms 

		TMC51=0x00;
		CR51=0xFA;		// 1ms 

		TCE51=1;
		MK1L.3=0;		// TM51荞݋ 
		counter_init();
		P0.1=1;
}

// dEdvʏ 
void voltage(unsigned char ch)
{
	volt=AD_Input(ch);
	if(volt>volt_Max)
	{
		volt_Max=volt;
	}

	sprintf(buf,"%4dm",V_Conv(volt));

	LCD_LPuts(buf,5,3,1);
	sprintf(buf,"Max:%4dm",V_Conv(volt_Max));

	LCD_CursorXY(1,3);
	LCD_Puts(buf,9);
	return;
}


// dlϊ֐ 
// ADl10idl[mV]ɕϊ 
// dat = 5000.0/1024.0 * data;
unsigned short V_Conv(int data)
{
	unsigned int dat;
	data &= 0x3ff;
	dat = data << 2;
	data >>= 1;
	dat += data;
	data >>= 1;
	dat += data;
	data >>= 1;
	dat += data;
	dat += data >> 4;
	return(dat);
}
